
TYPO3.Flow - Feature # 32333

Status: Resolved Priority: Must have
Author: Robert Lemke Category: Core
Created: 2011-12-06 Assigned To: Robert Lemke
Updated: 2011-12-21 Due date:
PHP Version:
Has patch: No
Complexity: hard
Subject: Modular and configurable bootstrap
Description

The bootstrap contains a big amount of specific initialization methods. The order of execution and selection of initialization methods is
hardwired in the Bootstrap class. This makes it impossible for package developers to provide alternative boot sequences for specific
tasks (such as for a very optimized caching mechanism) and in general results in a rather function-based, sequential code than being
object-oriented.

It thus should be possible to register Request Handlers for specific purposes and those should be in charge of the actual boot
sequence which is executed.

Related issues:
related to TYPO3.Flow - Bug # 32552: PackageStates are saved on each request Resolved 2011-12-14
related to TYPO3.ExtJS - Bug # 32821: ExtDirect Request Handler needs to be a... Resolved 2011-12-23

Associated revisions
Revision a7844b0d - 2011-12-09 10:00 - Robert Lemke

[TASK] Optimized package manager and configuration manager initialization

This patch introduces a somewhat lazier initialization for the
Configuration Manager's cache and the scanning of available packages
and loading of package state information.

NOTE: On the first hit, the modified Package Manager will introduce
a new format for the PackageStates.php. From now on the configuration
in that file also contains a version number which allows for automatic
migration of that file in the future.

Change-Id: I690baafd2fafa24dd104950eea82b10815280427
Related: #32333
Releases: 1.1

Revision ae111dd0 - 2011-12-09 10:01 - Robert Lemke

[FEATURE][!!!] Modular and configurable bootstrap

This extracts all specific initialization methods from the bootstrap
into a "Scripts" class and instead of hard-wiring each initialization
step, introduces a loose, configurable coupling by means of a sequence
and steps. The responsibility for the actual boot sequence now lies at
the request handler taking care of the request.
Request handlers must now be explicitly registered in the package
class. The interface to be implemented was moved to the Core namespace.

Resolves: #32333
Releases: 1.1

Change-Id: I467a2a3b02167087a23dba1eb64d1a9747eac8ba

History
#1 - 2011-12-06 13:54 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6997

#2 - 2011-12-06 19:04 - Christopher Hlubek

After testing the patch I found at least one problem:

    -  The activation of new packages does not work with this patch applied. "flow3 package:list" does not show an inactive, new package.

#3 - 2011-12-07 09:47 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6997

#4 - 2011-12-07 10:29 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6997

#5 - 2011-12-07 12:54 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6997

#6 - 2011-12-07 14:45 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6997

#7 - 2011-12-08 12:36 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6997
#8 - 2011-12-09 09:52 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6997

#9 - 2011-12-09 09:54 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6997

#10 - 2011-12-09 10:01 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6997

#11 - 2011-12-09 10:06 - Robert Lemke
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ae111dd0a0f15e548989d45c0186f4e4ec30bbf9.

#12 - 2011-12-21 12:38 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1 beta 1
